package LeonTama.Affichage;
import LeonTama.Affichage.LeonImage;
import java.awt.*;
import javax.swing.*;
import java.io.*;

/**
 * Displays a centered image in the available area. If the picture is too big
 * (width or height), a zoom will be applied in order to show the full image.
 * This class works also if the picture is in a jar file.
 * @author Michel Deriaz 
 */
public class LeonImage extends JPanel {
  private Image img;      


  /**
   * Loads the specified image, which must be a JPG, a GIF, or a PNG.
   * @param file the file to load
   */  
  public LeonImage(String file) {
	try
	{
		img = new ImageIcon(getClass().getResource(file)).getImage();
	}
	catch(Throwable t)
	{
		System.out.println("Erreur lors de la lecture de l'image : "+t);
	}
    repaint(); 
  }
 
  public LeonImage(Image file) {
	img = file;
    repaint(); 
  } 

  public void paintComponent(Graphics g) {
    super.paintComponent(g);
    if (img == null) return;
    int w = img.getWidth(this);  
    int h = img.getHeight(this);
    boolean zoom = (w > getWidth() || h > getHeight());
    if (zoom) g.drawImage(img, 0, 0, getWidth(), getHeight(), this);
    else g.drawImage(img, (getWidth()-w)/2, (getHeight()-h)/2, this);
  }
  
  public Image getImage()
  {
	return img;
  }
}