package LeonTama.Jeu;
import LeonTama.Affichage.*;
import LeonTama.Tama.Tamagoshi;
import LeonTama.Fichiers.LeonFile;

import javax.swing.*;
import java.awt.*;
import java.util.*;
import javax.swing.*;
import java.awt.event.*;
import java.io.*;
import java.net.URL;
class LeonTama extends JFrame
{
	private static String skin = "Standard";	
	private static String [] tamaSave;
	
	private static JFrame LTFenetre;
	private static Container pan;
	private static LeonTama l;
	private static Tamagoshi tama;
	private static LeonImage blancImage;
	private static LeonImage heureuxImage;
	private static LeonImage boudeImage;
	private static LeonImage faimImage;
	private static LeonImage ennuiImage;
	private static LeonImage sommeilImage;
	private static LeonImage dortImage;	
	private static LeonImage mortImage;
	
	private static LeonImage icone			= new LeonImage(Toolkit.getDefaultToolkit().getImage("../Imgs/Standard/icon.gif"));		
	private static LeonImage iconeSad		= new LeonImage(Toolkit.getDefaultToolkit().getImage("../Imgs/Standard/iconSad.gif"));		
	private static LeonImage iconeSleep		= new LeonImage(Toolkit.getDefaultToolkit().getImage("../Imgs/Standard/iconSleep.gif"));		
	private static LeonImage iconeDead		= new LeonImage(Toolkit.getDefaultToolkit().getImage("../Imgs/Standard/iconDead.gif"));		
	private static LeonImage currentImage 	= blancImage;
	private static LeonImage nextImage	 	= null;
	
	private static JMenuItem nouveau;
	private static JMenuItem modifSkin;
	private static JMenuItem quit;
	private static JMenuItem nourrir;
	private static JMenuItem jouer;
	private static JMenuItem eteindre;
	private static JMenuItem statut;
	private static JMenuItem help;
	private static JMenuItem apropos;
	
	/**
	Constructeur par defaut
	*/
	public LeonTama()
	{
		chargerImages( true );
		
		initFenetre();
		initBarreMenu();
		footFenetre();
		
		charger( "../Data/Save.dat" );
	
	}
	
	/**
	Cree un Tama a partir de tout ses parametres s'ils sont faux, cree un nouveau tama
	*/
	private static void chargerTama()
	{
		int timeNow = (int)(new Date().getTime()/60000);
		tama = new Tamagoshi(tamaSave[0],Integer.parseInt(tamaSave[1]),Integer.parseInt(tamaSave[2]),Integer.parseInt(tamaSave[3]),Integer.parseInt(tamaSave[4]),Integer.parseInt(tamaSave[5]),Integer.parseInt(tamaSave[6]),Integer.parseInt(tamaSave[7]),Integer.parseInt(tamaSave[8]));
		
		timeNow-=Integer.parseInt(tamaSave[9]);
		
		if(timeNow >= 0 )
		{
		
			if(tamaSave[11]!="")
				setSkin(tamaSave[11]);		
		
			if( Integer.parseInt(tamaSave[10]) == 1)
				tama.eteindreAllumer();
			while( timeNow-- > 0 )
				consome();
		}
		else
			creerTama();
	}

	/**
	Cree un nouveau Tama en demandant son nom
	*/	
	private static void creerTama()
	{
		String s = JOptionPane.showInputDialog(null,"Nom de Votre Tamagoshi :","Nouvau Tamagoshi",JOptionPane.PLAIN_MESSAGE);
		
		if(s==null || s=="" || s==" ")
			s="NoName";
				
		tama = new Tamagoshi(s);
		
		// On active les menus suivants :
		nourrir.setEnabled	(true);
		jouer.setEnabled	(true);
		eteindre.setEnabled	(true);
		statut.setEnabled	(true);		
	}	

	public static void save( String file )
	{
		Writer flux=null;	
		
		String sleep;
		
		if(tama.getEtat() == Tamagoshi.DORT)
			sleep = "1";
		else
			sleep = "0";
	
		try
		{
			flux = new FileWriter(file);
			flux.write( tama.save()+""+Integer.toString((int)((new Date()).getTime()/60000))+""+sleep+""+skin );		
		}
		catch( Throwable t )
		{
			System.out.println("Erreur sauvegarde Impossible, votre Tamagoshi ne sera pas sauvegarde");
		}
		finally
		{
			try
			{
				if(flux !=null )
				{
					flux.close();
				}
			}
			catch(IOException ex)
			{
					ex.printStackTrace();
				
			}
		}
	}
	
	public static void charger( String file )
	{
		BufferedReader flux = null;
		
		try
		{
			flux = new BufferedReader(new FileReader( file ));
			String a = flux.readLine();			
			tamaSave = a.split("");	
		}
		catch( Throwable t )
		{
			tamaSave = new String[0];
		}
		finally
		{
			try
			{
				if(flux !=null )
				{
					flux.close();
				}
			}
			catch(IOException ex)
			{
					ex.printStackTrace();
				
			}
		}
		
		System.out.println(tamaSave.length);
		
		for(int i=0;i<tamaSave.length;i++)
		{
			System.out.println(tamaSave[i]);
		}
		
		if(tamaSave.length != 12 )
		{
			creerTama();
		}
		else
		{
			chargerTama();
		}
	}
	
	/**
	Initialise la Fenetre
	*/
	private void initFenetre()
	{
		// Change de LookAndFeel
	
		try {UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());} 
		catch (Exception e) { e.printStackTrace();}	
		
		// Cr la fenetre
		
		LTFenetre = new JFrame ("LeonTama");
		pan = LTFenetre.getContentPane();	
		
		LTFenetre.setIconImage(icone.getImage());				
		
		LTFenetre.add(currentImage,BorderLayout.CENTER);			
	}

	/**
	Initialise la Barre de menu
	*/	
	public void initBarreMenu()
	{
	
		int racourci = java.awt.Toolkit.getDefaultToolkit().getMenuShortcutKeyMask();
	
		nouveau = new JMenuItem ("Nouveau", 'N');
		nouveau.setAccelerator ( KeyStroke.getKeyStroke( KeyEvent.VK_N, racourci ));			
		nouveau.addActionListener( new ActionListener ()	// on ferme pas la ')'
		{
			public void actionPerformed (ActionEvent ev )
			{
				if(JOptionPane.showConfirmDialog(null, "Voulez-vous vraiment supprimer le Tamagoshi : \""+tama.getNom()+"\" ?", "Nouveau Tamagoshi" , JOptionPane.YES_NO_OPTION , JOptionPane.QUESTION_MESSAGE ) == JOptionPane.YES_OPTION )
				{
					creerTama();	
					reloadImage();	
				}
			}
															
		}				);	
		
		modifSkin = new JMenuItem ("Changer Skin", 'N');
		modifSkin.setAccelerator ( KeyStroke.getKeyStroke( KeyEvent.VK_C, racourci ));			
		modifSkin.addActionListener( new ActionListener ()	// on ferme pas la ')'
		{
			public void actionPerformed (ActionEvent ev )
			{
				// cree la liste des dossiers presents dans le dossier image et cree un menu liste
				LeonFile fichier = new LeonFile("../Imgs");
				File[] listeFichiers = fichier.listDirectories();
				java.awt.List listeSkin = new java.awt.List(5,false);
				
				// rempli le menu liste avec les fichiers
				for(int i=0;i<listeFichiers.length;i++)
					listeSkin.add(listeFichiers[i].getName());
				
				// selectionne le 1er
				listeSkin.select(0);

				// cree l'interface graph
				JPanel contain   = new JPanel(new BorderLayout(5,5));					
				contain.add(new JLabel("Coisissez une Skin dans la liste suivante :"),BorderLayout.NORTH);
				contain.add(listeSkin,BorderLayout.CENTER);	

				// change le skin si ok
				if( JOptionPane.showConfirmDialog(null, contain, "Changer de Skin", JOptionPane.OK_CANCEL_OPTION , JOptionPane.PLAIN_MESSAGE ) == JOptionPane.OK_OPTION )
				{
					setSkin(listeSkin.getSelectedItem());
					reloadImage();
				}
			}											
		}				);			
	
		// Cree le truc 'QUITTER'
		quit = new JMenuItem ("Quitter", 'Q');
		quit.setAccelerator ( KeyStroke.getKeyStroke( KeyEvent.VK_Q, racourci ));		
		quit.addActionListener( new ActionListener ()	// on ferme pas la ')'
		{
			public void actionPerformed (ActionEvent ev )
			{
					System.exit(0);
			}
															
		}				);	
		
		nourrir = new JMenuItem ("Nourrir", 'N');
		nourrir.setAccelerator ( KeyStroke.getKeyStroke( KeyEvent.VK_1, racourci ));			
		nourrir.addActionListener( new ActionListener ()	// on ferme pas la ')'
		{
			public void actionPerformed (ActionEvent ev )
			{
					tama.manger();
					reloadImage();				
			}
															
		}				);	
		
		jouer = new JMenuItem ("Jouer", 'N');
		jouer.setAccelerator ( KeyStroke.getKeyStroke( KeyEvent.VK_2, racourci ));			
		jouer.addActionListener( new ActionListener ()	// on ferme pas la ')'
		{
			public void actionPerformed (ActionEvent ev )
			{
					tama.jouer();
					reloadImage();				
			}
															
		}				);	
		
		eteindre = new JMenuItem ("Eteindre / Allumer", 'N');
		eteindre.setAccelerator ( KeyStroke.getKeyStroke( KeyEvent.VK_3, racourci ));			
		eteindre.addActionListener( new ActionListener ()	// on ferme pas la ')'
		{
			public void actionPerformed (ActionEvent ev )
			{
					tama.eteindreAllumer();
					reloadImage();				
			}
															
		}				);		

		statut = new JMenuItem ("Statut", 'N');
		statut.setAccelerator ( KeyStroke.getKeyStroke( KeyEvent.VK_S, racourci ));			
		statut.addActionListener( new ActionListener ()	// on ferme pas la ')'
		{
			public void actionPerformed (ActionEvent ev )
			{
				JPanel contain   = new JPanel(new GridLayout(4,4,5,5));
				
				contain.add( new JLabel("Faim :") );
				contain.add( new JLabel(""+tama.getFaim()+" %") );
				contain.add( new JLabel("Idal :") );				
				contain.add( new JLabel("0 - 15 %") );				
				contain.add( new JLabel("Ennui :") );
				contain.add( new JLabel(""+tama.getEnnui()+" %") );
				contain.add( new JLabel("Idal :") );				
				contain.add( new JLabel("0 - 15 %") );	
				contain.add( new JLabel("Fatigue :") );
				contain.add( new JLabel(""+tama.getFatigue()+" %") );
				contain.add( new JLabel("Idal :") );				
				contain.add( new JLabel("5 - 20 %") );	
				contain.add( new JLabel("Boude :") );
				contain.add( new JLabel(""+tama.getBoude()+" %") );
				contain.add( new JLabel("Idal :") );				
				contain.add( new JLabel("0 %") );	
				
				JOptionPane.showMessageDialog( null, contain , "Statut de : "+tama.getNom() , JOptionPane.PLAIN_MESSAGE );			
			}
															
		}				);			
		
		help = new JMenuItem ("Aide", 'A');
		help.setAccelerator ( KeyStroke.getKeyStroke( KeyEvent.VK_H, racourci ));			
		help.addActionListener( new ActionListener ()	// on ferme pas la ')'
		{
			public void actionPerformed (ActionEvent ev )
			{
				JOptionPane.showMessageDialog( null, "<html>Pour consulter l'aide de <b>LeonTama</b>, rendez vous  : <u><b>LeonTama/Help/Index.html</b></u>" , "LeonTama :: Aide" , JOptionPane.PLAIN_MESSAGE );					
			}
															
		}				);				

		apropos = new JMenuItem ("A propos", 'A');	
		apropos.addActionListener( new ActionListener ()	// on ferme pas la ')'
		{
			public void actionPerformed (ActionEvent ev )
			{
				JOptionPane.showMessageDialog( null, "<html>Ce programme a t Ralis par Jrme Baudoux.<br><br>Date : 2006<br>Version : 1.0<br>Langage : Java 5.0</html>" , "LeonTama :: A propos" , JOptionPane.PLAIN_MESSAGE );					
			}
															
		}				);	
		
		JMenuBar barreMenu = new JMenuBar();
		LTFenetre.setJMenuBar (barreMenu);

		JMenu menuFichier = new JMenu("Fichier");	
		JMenu menuActions = new JMenu("Actions");			
		JMenu menuApropos = new JMenu("Aide");	
		
		barreMenu.add ( menuFichier );	
		barreMenu.add ( menuActions );			
		barreMenu.add ( menuApropos );	

		menuFichier.add ( nouveau 	);
		menuFichier.add ( modifSkin	);		
		
		menuFichier.add ( quit 		);	
		menuActions.add ( nourrir 	);			
		menuActions.add ( jouer 	);			
		menuActions.add ( eteindre 	);				
		menuActions.add ( new JSeparator() 	);				
		menuActions.add ( statut 	);	

		menuApropos.add ( help	 	);	
		menuApropos.add ( apropos 	);			
	}

	/**
	Initialise la Fenetre et l'affiche
	*/	
	public void footFenetre()
	{
		LTFenetre.setSize(150,160);
		
		// Changer position ecran
		
		LTFenetre.setLocationRelativeTo(LTFenetre.getParent());
		
		LTFenetre.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		LTFenetre.setResizable(false);
		LTFenetre.setVisible (true);		
	}
	
	/**
	Timer
	*/
	static class DateTask extends TimerTask 
	{
		
		public DateTask() 
		{
			reloadImage();		
		}
		public void run() 
		{
			if( tama.estVivant() )
			{
				consome();
				reloadImage();
			}
		}
	}	
	
	/**
	Consome toutes les energies
	*/
	private static void consome()
	{
		if(tama.consomeEnergie());
		if(tama.consomeFun());
		if(tama.consomeSommeil());
		tama.consomeBoudage();
	}	

	/**
	Modifi la valeur du skin
	@param s nom du skin
	*/
	private static void setSkin(String s)
	{
		skin = s;
		chargerImages(false);
		reloadImage();
	}
	
	/**
	Charge toutes les images de skin
	@param t recharger l'image courrante
	*/
	private static void chargerImages(boolean t)
	{
		blancImage		= new LeonImage(Toolkit.getDefaultToolkit().getImage("../Imgs/"+skin+"/blanc.gif"));
		heureuxImage 	= new LeonImage(Toolkit.getDefaultToolkit().getImage("../Imgs/"+skin+"/heureuxAnim.gif"));
		boudeImage 		= new LeonImage(Toolkit.getDefaultToolkit().getImage("../Imgs/"+skin+"/boudeAnim.gif"));
		faimImage		= new LeonImage(Toolkit.getDefaultToolkit().getImage("../Imgs/"+skin+"/faimAnim.gif"));
		ennuiImage 		= new LeonImage(Toolkit.getDefaultToolkit().getImage("../Imgs/"+skin+"/ennuiAnim.gif"));
		sommeilImage 	= new LeonImage(Toolkit.getDefaultToolkit().getImage("../Imgs/"+skin+"/sommeilAnim.gif"));
		dortImage 		= new LeonImage(Toolkit.getDefaultToolkit().getImage("../Imgs/"+skin+"/dortAnim.gif"));	
		mortImage 		= new LeonImage(Toolkit.getDefaultToolkit().getImage("../Imgs/"+skin+"/mort.gif"));
		if( t )
		{
			currentImage	= blancImage;
			nextImage 		= null;
		}
	}

	/**
	Rafraichie image et sauvegarde
	*/
	private static void reloadImage()
	{
		modifCurrentImage();
		effaceAncienneImage();				
		changeImage();
		save("../Data/Save.dat");		
	}
	
	/**
	Efface image courrante
	*/
	private static void effaceAncienneImage()
	{
		if( ! nextImage.equals(currentImage) )
			LTFenetre.remove(currentImage);

	}
	
	/**
	charge la nouvelle image suivante dans l'image courrante
	*/
	private static void changeImage()
	{
		if( ! nextImage.equals(currentImage) )
		{
			LTFenetre.add(nextImage,BorderLayout.CENTER);	
			LTFenetre.validate();
			currentImage = nextImage;
		}

	}
	
	/**
	modifie l'image suivante
	*/
	private static void modifCurrentImage()
	{
		if(tama.getEtat() == Tamagoshi.BON)
		{
			nextImage = heureuxImage;
			LTFenetre.setTitle("Heureux :: "+tama.getNom());
			LTFenetre.setIconImage(icone.getImage());					
		}
		else
			if(tama.getEtat() == Tamagoshi.BOUDE)
			{
				nextImage = boudeImage;
				LTFenetre.setTitle("Boude :: "+tama.getNom());
				LTFenetre.setIconImage(iconeSad.getImage());		
			}
			else
				if(tama.getEtat() == Tamagoshi.FAIM)
				{
					nextImage = faimImage;
					LTFenetre.setTitle("Affam :: "+tama.getNom());
					LTFenetre.setIconImage(iconeSad.getImage());		
				}
				else
					if(tama.getEtat() == Tamagoshi.SOMMEIL)
					{
						nextImage = sommeilImage;
						LTFenetre.setTitle("Fatigu :: "+tama.getNom());
						LTFenetre.setIconImage(iconeSad.getImage());		
					}
					else
						if(tama.getEtat() == Tamagoshi.ENNUI)
						{
							nextImage = ennuiImage;
							LTFenetre.setTitle("Deprim :: "+tama.getNom());
							LTFenetre.setIconImage(iconeSad.getImage());		
						}
						else
							if(tama.getEtat() == Tamagoshi.MORT)
							{
								nextImage = mortImage;
								LTFenetre.setTitle("Mort :: "+tama.getNom());
								LTFenetre.setIconImage(iconeDead.getImage());
								
								// On bloque les menus suivants :
								nourrir.setEnabled	(false);
								jouer.setEnabled	(false);
								eteindre.setEnabled	(false);
								statut.setEnabled	(false);
							}
							else
							{
								nextImage = dortImage;	
								LTFenetre.setTitle("Endormi :: "+tama.getNom());	
								LTFenetre.setIconImage(iconeSleep.getImage());				
							}
	}	
	

	/**
	Main
	*/	
	public static void main( String [] arg )
	{
		l = new LeonTama();
		
		// Ajoute un Timer
		
		java.util.Timer timer = new java.util.Timer();
		DateTask task0 = new DateTask();
		timer.schedule(task0, 60000, 60000);
	}
}