package LeonTama.Tama;
import LeonTama.Tama.Tamagoshi;
import java.util.*;

public class Tamagoshi
{
	// Tamagoshi
	private String nom;
	private int energie;
	private int energieMax;
	private int fun;
	private int funMax;
	private int sommeil;
	private int sommeilMax;
	private int boudage;
	private int boudageMax;
	private boolean dort;
	
	// Variables Statiques
	public static int BON		=0;
	public static int BOUDE		=1;
	public static int FAIM		=2;
	public static int ENNUI		=3;
	public static int SOMMEIL	=4;
	public static int MORT		=5;
	public static int DORT		=6;
	
	// Radom
	private static Random rand = new Random(System.currentTimeMillis());
		
	
	public Tamagoshi( String n )
	{
		nom = n;
		energie 	= (int) rand.nextInt(40)+1990;
		energieMax 	= (int) rand.nextInt(40)+3490;
		fun 		= (int) rand.nextInt(40)+210;
		funMax 		= (int) rand.nextInt(40)+580;
		sommeil 	= (int) rand.nextInt(40)+1410;
		sommeilMax 	= (int) rand.nextInt(40)+1540;
		boudage 	= 0;
		boudageMax 	= (int) rand.nextInt(30)+45;
		dort		= false;		
	}
	
	public Tamagoshi( String n, int e, int em, int f, int fm, int s, int sm, int b, int bm)
	{
		nom 		= n;
		energie 	= e;
		energieMax 	= em;
		fun 		= f;
		funMax 		= fm;
		sommeil 	= s;
		sommeilMax 	= sm;
		boudage 	= b;
		boudageMax 	= bm;	
		dort 		= false;
	}
	
	public boolean consomeEnergie()
	{
		if( dort )
			energie--;
		else
			if( sommeil <= sommeilMax*10/100 )
				energie-=12;
			else
				energie-=6;
			
		if( energie <= 0 )
		{
			energie = 0;
			return false;
		}
		
		if( energie <= energieMax*20/100 && dort )
			eteindreAllumer();
		
		return true;
	}
	
	private void consomeEnergie(int nb)
	{
		if( energie > 35 )
			energie-=nb;
		else
			energie-= 5;
			
		if(energie < 0)
			energie = 0;
	}		
	
	public boolean consomeFun()
	{
		if( ! dort )
			fun--;
			
		if( fun <= 0 )
		{
			fun = 0;
			boudage = boudageMax;
			return false;
		}
		
		return true;
	}
	
	public boolean consomeSommeil()
	{
		if( dort )
		{
			sommeil+=3;
			
			if(sommeil >= sommeilMax)
			{
				sommeil = sommeilMax;
				dort = !dort;
			}
		}
		else
		{
			sommeil--;
		}
		
		if( sommeil <=0 )
		{
			sommeil = 0;
			return false;
		}
		
		return true;
	}
	
	private void consomeSommeil(int nb)
	{
		sommeil-=nb;
		
		if( sommeil <=0 )
		{
			sommeil = 0;
		}
	}	
	
	public void consomeBoudage()
	{
		if( boudage > 0 )
			boudage--;
	}
	
	public void eteindreAllumer()
	{
		if( sommeil < ( sommeilMax*90/100 ) )
		dort = ! dort;
	}
	
	public boolean manger()
	{
		if( !dort && boudage==0 && energie > 0)
		{
			if( energie >= ( energieMax*80/100 ) )
			{
				boudage = boudageMax;
			}
			else
			{
				energie += energieMax*40/100;
				if( energie > energieMax)
					energie = energieMax;
				return true;
			}
		}
		
		return false;
	}
	
	public boolean jouer()
	{
		if( !dort && boudage==0 && energie > 0)
		{
			if( fun > ( funMax*90/100 ) )
			{
				boudage	= boudageMax*20/100;	
			}
			else
			{
				consomeSommeil(5);
				consomeEnergie(5);				
				fun += funMax*40/100;
				if( fun > funMax)
					fun = funMax;
				return true;
			}
		}
		
		return false;	
	}
	
	public int getEtat()
	{
		if(energie == 0)
			return 5;	
			
		if( dort )
			return 6;			
			
		if( boudage > 0 )
			return 1;
		
		if( energie*100/energieMax <= fun*100/funMax || energie <= energieMax*25/100)
		{
			if( energie <= energieMax*65/100)
				return 2;
		}
		else
		{
			if( fun <= funMax*65/100 )
				return 3;
		}
		
		if( sommeil <= sommeilMax*15/100 )
			return 4;
			
		return 0;
	}
	
	public String toString()
	{
		return "nom : "+nom+" energie :"+energie+" eMax : "+energieMax+" fun : "+fun+" fMax : "+funMax+" s "+sommeil+" sMax "+sommeilMax+" boude "+boudage+" bMax "+boudageMax+" dort : "+dort;
	}
	
	public String save()
	{
		return nom.replace('','\\')+""+energie+""+energieMax+""+fun+""+funMax+""+sommeil+""+sommeilMax+""+boudage+""+boudageMax;	
	}
	
	public boolean estVivant()
	{
		return energie>0;
	}
	
	public String getNom()
	{
		return nom;
	}
	
	public int getFaim()
	{
		return 100-energie*100/energieMax;
	}	
	
	public int getEnnui()
	{
		return 100-fun*100/funMax;
	}	
	
	public int getFatigue()
	{
		return 100-sommeil*100/sommeilMax;
	}
	
	public int getBoude()
	{
		return boudage*100/boudageMax;
	}
	
}